/**************************************************************************************************

Copyright (c) 2015   Tsunehiko Kato  and  4D2U Project, National Astronomical Observatory of Japan

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

ȉɒ߂ɏ]A{\tgEFAъ֘Ãt@Ciȉu\tgEFAvj̕擾
邷ׂĂ̐lɑ΂A\tgEFA𖳐ɈƂ𖳏ŋ܂Bɂ́A\tgEFA̕
gpAʁAύXAAfځAЕzATuCZXA/܂͔̔錠Aу\tgEFA
񋟂鑊ɓƂ錠Ɋ܂܂܂B

L̒쌠\і{\A\tgEFÂׂĂ̕܂͏dvȕɋLڂ̂Ƃ
B

\tgEFÁû܂܁vŁAł邩Öقł邩킸A̕ۏ؂Ȃ񋟂܂B
łۏ؂Ƃ́AiA̖ړIւ̓KAьNQɂĂ̕ۏ؂܂݂܂AɌ
̂ł͂܂B ҂܂͒쌠҂́A_sׁAs@sׁA܂͂ȊOł낤ƁA\t
gEFAɋN܂͊֘AA邢̓\tgEFA̎gp܂͂̑̈ɂĐ؂̐A
QȂ̋`ɂĉ̐ӔCȂ̂Ƃ܂B
***************************************************************************************************/
#include  "mtk_cmb.h"
#include  "mtk_OpenGL.h"
#include  "mtk_switches.h"
#include  "mtk_dialog_box.h"
#include  "mtk_our_galaxy_rt.h"




static GLuint texCMB;
const char *fn_tex_CMB = "CMB.jpg";




void
load_CMB_texture()
{
	SetSplashText("Fwi˂̃eNX`Ǎ...", "Loading textures of CMB...");
	texCMB = LoadTexture(fn_tex_CMB, TexShrinkRate);
}


void
draw_CMB_map(const mtk_draw_struct& ds, bool bFarSide)
{
	if (!bCMB) return;

	const float R = 138.0e8 * _1ly_pc;
	const float R1 = 0.1 * R;
	const float R2 = 0.8 * R;


	const float dist = norm(ds.camera_base.get_pos());
	float af, af1, af2;
	af = 0.4f;

	if (dist < R2) {
		float t = (dist - R1) / (R2 - R1);
		af *= t;
	}
	if (af <= 0.0) return;


	af1 = af;
	af2 = af*0.5;


	glEnable(GL_TEXTURE_2D);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_DEPTH_TEST);
	glBindTexture(GL_TEXTURE_2D, texCMB);
	glEnable(GL_CULL_FACE);


	vector3f rpos = -ds.camera.get_pos();


	glPushMatrix();

		glTranslatef(rpos.x, rpos.y, rpos.z);

		go_to_galactic_coord();

		glScalef(R, R, R);
	
		glRotatef(180, 0, 0, 1);
		if (bFarSide) {
			glColor4f(1, 1, 1, af1);
			glFrontFace(GL_CW);
			gl_draw_sphere(5, true);
		}
		else {
			glColor4f(1, 1, 1, af2);
			glFrontFace(GL_CCW);
			gl_draw_sphere(5, true);
		}
		glPopMatrix();

	glEnable(GL_DEPTH_TEST);
	glDisable(GL_TEXTURE_2D);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}
